#!/bin/sh

#  moveICoreConfig.sh
#  SupportTool
#
#  Created by David Cai on 4/1/13.
#

ICORE_CONFIG_FOLDER=/Library/Application\ Support/TrendMicro/common/conf

usage()
{
    echo "Usage: $0 get <CONFIG_PLIST_FILE> <COPY_TO_FILE>" >&2;
    echo "          set <CONFIG_PLIST_FILE>" >&2;
}

getICoreConfigFile()
{
    CONFIG_PLIST_FILE="$1"
    COPY_TO_FILE="$2"

    if [ -z $CONFIG_PLIST_FILE -o -z $COPY_TO_FILE ]; then
        usage;
        return -1;
    fi

    echo "$ICORE_CONFIG_FOLDER/$CONFIG_PLIST_FILE -> $COPY_TO_FILE";
    fileDir=`dirname $COPY_TO_FILE`;
    mkdir -p "$fileDir";
    chmod o+rw "$fileDir";
    cp "$ICORE_CONFIG_FOLDER/$CONFIG_PLIST_FILE" "$COPY_TO_FILE";
    chmod o+rw "$COPY_TO_FILE";

    return 0;
}

setICoreConfigFile()
{
    CONFIG_PLIST_FILE="$1"

    if [ -z $CONFIG_PLIST_FILE ]; then
        usage;
        return -1;
    fi

    chmod o-rw "$CONFIG_PLIST_FILE";
    cp "$CONFIG_PLIST_FILE" "$ICORE_CONFIG_FOLDER";
    rm "$CONFIG_PLIST_FILE";

    return 0;
}

user=`whoami`
if [ $user != "root" ]; then
    echo "Error! stop with user '$user'. Make sure you are 'root'!";
    exit 1;
fi

OPT="$1"
if [ -z $OPT ]; then
    usage;
    exit 1;
fi

RET=0
case "$OPT" in
    no)
        echo "no operation";
        RET=0
        ;;
    get)
        getICoreConfigFile "$2" "$3";
        RET=$?
        ;;

    set)
        setICoreConfigFile "$2";
        RET=$?
        ;;

    *)
        usage;
        RET=-1
        ;;
esac
exit $RET;
